﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;
using Infragistics.Win.UltraWinToolTip;
using System.Threading;
using System.Diagnostics;
using Infragistics.Win.Misc;

namespace UltraTreeNodeDragToolTip
{
    public partial class Form1 : Form
    {
        private UltraTreeNode SN;
        private string CurrentNode;
        public delegate void DelegateDefinition();
        private System.Windows.Forms.Timer timer;

        public Form1()
        {
            InitializeComponent();
            timer = new System.Windows.Forms.Timer();
            timer.Interval = 100;
            timer.Tick += new EventHandler(timer_Tick);
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            timer.Stop();
            DelegateDefinition delgate = new DelegateDefinition(CreateToolTip);
            ThreadStart threadStart = new ThreadStart(delegate { this.BeginInvoke(delgate); });
            Thread thread = new Thread(threadStart);
            thread.Start();
            timer.Start();
        }

        public void CreateToolTip()
        {
            UltraToolTipInfo info = new UltraToolTipInfo();
            info.ToolTipText = CurrentNode;
            UltraToolTipManager man = new UltraToolTipManager();
            man.InitialDelay = 10;
            man.AutoPopDelay = 250;
            man.SetUltraToolTip(this, info);
            man.ShowToolTip(this);
        }


        private void ultraTree1_SelectionDragStart(object sender, EventArgs e)
        {
            timer.Enabled = true;
            SN = ultraTree1.ActiveNode;
            SN.Remove();
            ultraTree1.DoDragDrop(ultraTree1.ActiveNode, DragDropEffects.Move);
        }


        private void ultraTree1_DragDrop(object sender, DragEventArgs e)
        {
            timer.Enabled = false;
            UIElement a = ultraTree1.UIElement.ElementFromPoint(ultraTree1.PointToClient(new Point(e.X, e.Y)));
            UltraTreeNode Node = a.GetContext(typeof(UltraTreeNode)) as UltraTreeNode;
            if (Node != null) Node.Nodes.Add(SN);
        }

        private void ultraTree1_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }

        private void ultraTree1_DragOver(object sender, DragEventArgs e)
        {
            UIElement a = ultraTree1.UIElement.ElementFromPoint(ultraTree1.PointToClient(new Point(e.X, e.Y)));
            UltraTreeNode Node = a.GetContext(typeof(UltraTreeNode)) as UltraTreeNode;
            if (Node != null) CurrentNode = Node.Text;
            if (CurrentNode == null) CurrentNode = "N/A";
        }

    }
}
